require("luamods/command")
require("luamods/layout")
require("luamods/cgi")
require("config/rsm_conf")
require("luamods/rsm_serials")

header = layout.getHeader()
footer = layout.getFooter()

userLevel = db.getPriv(layout.username) or 1

function log(m)
   command.ex([[logger -t webconfig ]]..[["]]..m..[["]])
end

if (userLevel == 1) then
    buttonControl = " disabled"
    inputControl = " readonly"
else
    buttonControl = ""
    inputControl = ""
end

serialConfig = command.ex([[cat ]]..rsm_conf.serialconfig_path) or ""

naradadConfig = command.ex([[cat ]]..rsm_conf.naradad_conf_path) or ""
if (naradadConfig ~= "") then
    naradadPath = naradadConfig:match([[naradad.device.dir=(.*)%$]]) or "/etc/rsm/naradad/devices/"
    
end

if (cgi.post.deleteButton == "Delete Device") and (userLevel ~= 1) then
    file = cgi.post.file or ""
    file = file:gsub("[^%w%.]+","")
    command.ex(rsm_conf.naradad_down)
    command.ex([[rm ]]..naradadPath..[[/]]..file)
    command.ex(rsm_conf.naradad_up)
    label = cgi.post.label or "unknown"
    bus = cgi.post.bus or "unknown"
    -- Stop here
    content = [[
                    <div id="info">
                        <center><h1>Edit Narada Device</h1></center>
                    </div>                  
                    <div id="info">
                        <center>
                            <h2><img src="images/ok.png"/> Device Deleted</h2>
                            Device with filename "]]..file..[[" has been removed.<br><br>
                            <a href="rsm_naradad_config.lua?bus=]]..bus..[[">Back to Narada</a>
                        </center>
                    </div>
]]
    print(header..content..footer)
    os.exit()
end

if (cgi.post.saveButton == "Save and Apply") and (userLevel ~= 1) then
    newFile = cgi.post.file or ""
    newFile = newFile:gsub("[^%w%.]+","")

    if (newFile == "") then
        newSerial = rsm_serials.generateNewSerial()
        newFile = newSerial..".xml"
        createdNew = 1
    else
        createdNew = 0
        existingCfg = command.ex([[cat ]]..naradadPath..[[/]]..newFile)
        newSerial = existingCfg:match([[<serial>%s-(.-)%s-</serial>]])
        if (newSerial == nil) then
            -- Bail on error
            content = [[
                    <div id="info">
                        <center><h1>Edit Narada Device</h1></center>
                    </div>                  
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Filename / serial mismatch</h2>
                            The serial number of the device does not match the one in the file.<br>
                            <a href="rsm_bus_config.lua">Back to Bus Configuration</a>
                        </center>
                    </div>
]]
            print(header..content..footer)
            os.exit()
        end
    end
    newLabel = cgi.post.label or "unknown"
    newConfig = cgi.post.config or rsm_conf.serialconfig_path
    newPort = cgi.post.bus or "unknown" 
    newAddress = cgi.post.address or "unkown"
    

    
    newXML = [[
<!-- ]]..naradadPath..[[/]]..newFile..[[ generated by webconfig -->
<device>
    <label>]]..newLabel..[[</label>
    <serial>]]..newSerial..[[</serial>
    <address>]]..newAddress..[[</address>
    <serialport>
        <config>]]..newConfig..[[</config>
        <port>]]..newPort..[[</port>
    </serialport>
</device>
<!-- end of file -->
]]
    command.ex(rsm_conf.naradad_down)
    command.log("naradadPath: " .. naradadPath)
    command.writefile(naradadPath..[[/]]..newFile, newXML)
    command.ex(rsm_conf.naradad_up)
    filename = newFile
    saved = 1
    mode = "edit"
else
    filename = cgi.get.file or ""
    if (filename == "") then 
        mode = "new"
    else 
        filename = filename:gsub("[^%w%.]+","")
        mode = "edit"
    end
end    

bus = cgi.get.bus or cgi.post.bus or ""

b, bCfg = serialConfig:match([[<port%s+device=%"(]]..bus..[[)%"%s->(.-)</port>]])
if (b == bus) and (bCfg ~= nil) then
    if bCfg:match("<owner>%s-naradad%s-</owner>") == nil then
        mismatch = 1
    else
        mismatch = 0
    end
else
    mismatch = 1
end

if (mode == "edit") then
    
    cfg = command.ex([[cat ]]..naradadPath..[[/]]..filename) or ""
    if (cfg:match("<device>(.+)</device>") == nil) then
        -- bail on error
        content = [[
                    <div id="info">
                        <center><h1>Edit Narada Device</h1></center>
                    </div>            
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Invalid file</h2>
                            The specified file does not appear to be a valid Narada device file.<br><br>
                            <a href="rsm_bus_config.lua">Back to bus configuration</a>
                        </center>
                    </div>
]]
        print(header..content..footer)
        os.exit()
    else
        d = {}
        d.label = cfg:match([[<label>%s-(.-)%s-</label>]]) or "unknown"
        d.serial = cfg:match([[<serial>%s-(.-)%s-</serial>]]) or "unknown"
        d.address = cfg:match([[<address>%s-(.-)%s-</address>]]) or "unknown"
        d.config = cfg:match([[<config>%s-(.-)%s-</config>]]) or rsm_conf.serialconfig_path
        d.port = cfg:match([[<port>%s-(.-)%s-</port>]])
        if (d.port ~= bus) then
            -- bail on error
            content = [[
                    <div id="info">
                        <center><h1>Edit Narada Device</h1></center>
                    </div>            
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Device / bus mismatch</h2>
                            The device being edited is not on the currently selected bus.<br><br>
                            <a href="rsm_bus_config.lua">Back to bus configuration</a>
                        </center>
                    </div>
]]
            print(header..content..footer)
            os.exit()            
        end
    end
else
    d = {}
    d.label = ""
    d.serial = "(unassigned)"
    d.address = ""
    d.config = rsm_conf.serialconfig_path
    d.port = bus
    
    
end

content = ""

if (mode == "new") then
    content = content .. [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Add New Narada Device</h1></center>
                        </div>
                    </div>
]]
else
    content = content .. [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Edit Narada Device</h1></center>
                        </div>
                    </div>
                    <h3>Editing device "]]..d.label..[[" with filename "]]..filename..[[" :</h3>
]]    
end

if (mismatch == 1) then
    -- Bail on error here
    content = [[
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Invalid bus</h2>
                            Either an invalid bus was specified, or the bus cannot be matched<br>
                            to a valid Narada entry in the serial config file "]]..rsm_conf.serialconfig_path..[[".<br><br>
                            <a href="rsm_bus_config.lua">Back to bus configuration</a>
                        </center>
                    </div>
]]
    html = header..content..footer
    print(html)
    os.exit()
end

if (userLevel == 1) then
    content = content .. [[
                    <center><b>Note:</b> Editing this section requires administrator privileges.</center><br>
]]
end

content = content .. [[
                    <script>
                        var doValidate = 0;
                        function validateForm(form)
                        {
                            
                            if (form.getAttribute('submitted')) return false;
                            
                            if (!doValidate)
                            {
                                form.setAttribute('submitted','true');
                                return true;
                            }
                            doValidate = 0;
                            
                            var inputs = form.getElementsByTagName("input");
                            
                            var loop;
                            var errors = 0;
                            for (loop = 0; loop < 4; loop++)
                            {
                                var warning = document.getElementById("warning"+loop);
                                if (inputs[loop].value == "")
                                {
                                    if (!warning)
                                    {
                                        warning = document.createElement("span");
                                        warning.id = "warning"+loop;
                                        warning.innerHTML = " <img src='images/warning.png' alt='Cannot be blank' title='Cannot be blank'/>";
                                        inputs[loop].parentNode.appendChild(warning);
                                    }
                                    errors++;
                                }
                                else
                                {
                                    if (warning)
                                    {
                                        warning.parentNode.removeChild(warning);
                                    }
                                }
                            }
                            
                            var template = document.getElementById("template");
                            warning = document.getElementById("templatewarning");                            
                            if (template.value == "Select a template")
                            {
                                if (!warning)
                                {
                                    warning = document.createElement("span");
                                    warning.id = "templatewarning";
                                    warning.innerHTML = " <img src='images/warning.png' alt='Choose a valid templatek' title='Choose a valid template'/>";
                                    template.parentNode.appendChild(warning);
                                }
                                errors++;
                            }
                            else
                            {
                                if (warning)
                                {
                                    warning.parentNode.removeChild(warning);
                                }
                            }
                            
                            if (errors)
                            {
                                alert("Not all fields have been filled in.\nPlease enter/select valid values for the indicated fields.");
                                return false;
                            }
                            else
                            {
                                form.setAttribute('submitted','true');
                                return true;
                            }
                        }
                    
                    </script>
                    
                    <form action="rsm_naradad_edit.lua" method="post" onsubmit="return validateForm(this);">
                        <div class="formLayoutfull">
                            <table class="onetwo">
                                <tr>
                                    <td style="padding: 5px;" width="50%">
                                        <b>Device Label:</b>
                                    </td>
                                    <td style="padding: 5px;" width="50%">
                                        <input type="text" name="label" value="]]..d.label..[["]]..inputControl..[[ id="label"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Device Serial:</b>
                                    </td>
                                    <td style="padding: 5px;">]]..d.serial..[[</td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Bus:</b>
                                    </td>
                                    <td style="padding: 5px;">]]..bus..[[</td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Device Address:</b>
                                    </td>
                                    <td style="padding: 5px;">
                                        <input type="text" name="address" value="]]..d.address..[["]]..inputControl..[[ id="address"/>
                                    </td>
                                </tr>

                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Serial Config:</b>
                                    </td>
                                    <td style="padding: 5px;">]]..d.config..[[</td>
                                </tr>
                                </table>
                                <br>
                                <hr>
                                <br>
]]
                                
if (saved == 1) then
    if (createdNew == 1) then
        content = content .. [[
                            <b><img src="images/ok.png"/> Saved new device with serial ]]..d.serial..[[</b><br><br>
]]
    else
        content = content .. [[
                            <b><img src="images/ok.png"/> Changes saved.</b><br><br>
]]            
    end
end
content = content .. [[
                            <input type="hidden" name="config" value="]]..d.config..[["/>
                            <input type="hidden" name="bus" value="]]..bus..[["/>
                            <input type="hidden" name="file" value="]]..filename..[["/>
                            <input type="button" name="backButton" value="Back to Narada" onclick="window.location.assign('rsm_naradad_config.lua?bus=]]..bus..[[');"/>
                            <input type="submit" name="saveButton" value="Save and Apply"]]..buttonControl..[[ onclick="doValidate = 1;"/>
]]
if (mode == "edit") then
    content = content .. [[
                            <input type="submit" name="deleteButton" value="Delete Device"]]..buttonControl..[[ onclick="return confirm('Are you sure you want to delete this device?');"/>
]]
end
content = content .. [[
                        </form>
                    </div>
                    
]]    

if (mode == "edit") then
    cfg = cfg:gsub("<","&lt;")
    cfg = cfg:gsub(">","&gt;")
    content = content .. [[    
                    <script>
                        function toggleVis(target)
                        {
                            if (target.style.display == "none")
                            {
                                target.style.display = "inline-block";
                            }
                            else
                            {
                                target.style.display = "none";
                            }
                            return false;
                        }
                    </script>
                    <br><img src="images/magnify.png"/> <a href="javascript:void(0)" onclick="toggleVis(document.getElementById('filecfg'));">View ]]..naradadPath..[[/]]..filename..[[</a></a><br>
        
                    <div id="filecfg" style="display: none;">
                        <pre class="formLayoutfull">
]]..cfg..[[
                        </pre>
                    </div>    
]]
end


print(header..content..footer)
